<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button class="btn btn-primary px-4" (click)="nuevo(modalEmpresa)" *ngIf="uso">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
</app-page-title>

<div class="card">
  <div class="card-body">

    <kendo-grid [kendoGridBinding]="dataGrid" [selectable]="true" [resizable]="true" [reorderable]="true"
      [sortable]="true" (selectionChange)="selectedEmpresa($event)" [pageSize]="pageSize" [skip]="skip"
      [filterable]="true" [pageable]="{ buttonCount: 5, pageSizes: [10, 25, 50] }" style="height: 70vh;">
      <kendo-grid-column field="Empresa" title="Empresa" width="120">
      </kendo-grid-column>
      <kendo-grid-column field="enombre" title="Nombre" width="240">
      </kendo-grid-column>
      <kendo-grid-column field="eciudad" title="Ciudad" width="180" [filterable]="false">
      </kendo-grid-column>
      <kendo-grid-column field="estado" title="Estado" width="110" [filterable]="false">
      </kendo-grid-column>
      <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
        <ng-template kendoGridFilterCellTemplate>
          <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
          </kendo-switch>
        </ng-template>
        <ng-template kendoGridCellTemplate let-dataItem>
          <span *ngIf="dataItem.Inactivo">Si</span>
          <span *ngIf="!dataItem.Inactivo">No</span>
        </ng-template>
      </kendo-grid-column>
      <kendo-grid-command-column width="170" *ngIf="uso">
        <ng-template kendoGridCellTemplate let-dataItem>
          <button class="btn btn-info mr-1" (click)="editarEmpresa(dataItem, modalEmpresa)">
            <i class="fas fa-edit mr-2"></i>Editar
          </button>
          <button class="btn btn-danger" (click)="eliminar(dataItem)">
            <i class="fas fa-trash-alt mr-2"></i>Eliminar
          </button>
        </ng-template>
      </kendo-grid-command-column>
    </kendo-grid>

  </div>
</div>

<!--Modals-->
<ng-template #tarifasModal let-c="close" let-d="dimiss" let-modal>
  <div class="modal-header">
    <h6 class="modal-title" id="modal-chart">Tarifas de Empresa</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row d-flex justify-content-end" *ngIf="uso">
      <button class="btn btn-primary btn-xy" (click)="nuevoButtons('T')">
        <i class="fas fa-plus mr-2"></i>Nuevo
      </button>
      <button class="btn btn-success btn-xy ml-1" (click)="serviceButtons(ngFormTarifas.value, 'T')"
        [disabled]="ngFormTarifas.invalid">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
    </div>

    <div class="divider"></div>
    <form [formGroup]="ngFormTarifas">
      <div class="row">
        <div class="form-group col-sm-3 col-md-3 col-lg-2 col-xl-2">
          <label>Empresa</label>
          <input type="text" class="form-control" formControlName="Empresa" readonly>
        </div>
        <div class="form-group col-sm-2 col-md-2 col-lg-2 col-xl-2">
          <label>Prov.</label>
          <input type="text" class="form-control" formControlName="prov" readonly>
        </div>

        <div class="form-group col-sm-6 col-md-6 col-lg-5 col-xl-5">
          <label>Tarifa</label>
          <kendo-combobox [data]="dsTarifas" [textField]="'tdesc'" [valueField]="'Tarifa'" formControlName="atarifa"
            (valueChange)="changeTarifa($event)" class="w-100" [readonly]="methodButtons === 'put'">
          </kendo-combobox>
        </div>
        <div class="form-group col-sm-4 col-md-4 col-lg-3 col-xl-3">
          <label>T.T.</label>
          <kendo-combobox [data]="dsTT" [textField]="'desc'" [valueField]="'tipo'" formControlName="atipo"
            [valuePrimitive]="true" class="w-100" [readonly]="methodButtons === 'put'">
          </kendo-combobox>
        </div>
      </div>
    </form>
    <kendo-grid [data]="gridDataTarifas" [height]="250" [selectable]="true" (selectionChange)="selectedTarifa($event)">
      <div *ngIf="gridDataTarifas.length !== 0">
        <kendo-grid-column field="prov" title="Prov" width="120">
        </kendo-grid-column>
        <kendo-grid-column field="Empresa" title="Empresa" width="260">
        </kendo-grid-column>
        <kendo-grid-column field="atarifa" title="Tarifa" width="260">
        </kendo-grid-column>
        <kendo-grid-column field="atipo" title="T.T." width="260">
        </kendo-grid-column>
        <kendo-grid-command-column width="70" *ngIf="uso">
          <ng-template kendoGridCellTemplate let-dataItem>
            <button class="btn btn-danger" (click)="serviceButtons(dataItem, 'T', 'delete')">
              <i class="fas fa-trash-alt"></i>
            </button>
          </ng-template>
        </kendo-grid-command-column>
      </div>
      <ng-template kendoGridNoRecordsTemplate>
        No se encontraron registros
      </ng-template>
    </kendo-grid>
    <kendo-grid [data]="gridDataTarifasDetalles" [height]="220" [selectable]="true">
      <div *ngIf="gridDataTarifasDetalles.length !== 0">
        <kendo-grid-column field="proc" title="Proc." width="70"></kendo-grid-column>
        <kendo-grid-column field="tdesc" title="Descripción" width="250b"></kendo-grid-column>
        <kendo-grid-column field="tmon" title="Mon." width="80"></kendo-grid-column>
        <kendo-grid-column field="ttfl" title="T.F.L." width="70">
          <ng-template kendoGridCellTemplate let-dataItem>
            <span *ngIf="dataItem.ttfl">Si</span>
            <span *ngIf="!dataItem.ttfl">No</span>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tprom" title="Prom." width="70">
          <ng-template kendoGridCellTemplate let-dataItem>
            <span *ngIf="dataItem.tprom">Si</span>
            <span *ngIf="!dataItem.tprom">No</span>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tdesde" title="Desde" width="130">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.tdesde | date: formatKendo }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="thasta" title="Hasta" width="130">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.thasta | date: formatKendo }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tgratis" title="Gratis" width="70"></kendo-grid-column>
        <kendo-grid-column field="tnoches" title="Por cada" width="100"></kendo-grid-column>
        <kendo-grid-column field="tminimo" title="Mínimo" width="100"></kendo-grid-column>
        <kendo-grid-column field="tpt" title="Prorratea" width="110">
          <ng-template kendoGridCellTemplate let-dataItem>
            <span *ngIf="dataItem.tprom">Si</span>
            <span *ngIf="!dataItem.tprom">No</span>
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="ttarifa" title="Tarifa Cont." width="200"></kendo-grid-column>
      </div>
      <ng-template kendoGridNoRecordsTemplate>
        No se encontraron registros
      </ng-template>
    </kendo-grid>
  </div>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click')">
      Cerrar
    </button>
  </div>
</ng-template>



<ng-template #modalEstado let-c="close" let-d="dimiss" let-modal>
  <div class="modal-header">
    <h6 class="modal-title" id="modal-chart">Selección de Estado</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <app-help-estado (estado)="resultEstado($event); c('Close click');"></app-help-estado>
  </div>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click')">
      Cerrar
    </button>
  </div>
</ng-template>

<ng-template #modalRfc let-c="close" let-d="dimiss" let-modal>
  <div class="modal-header">
    <h6 class="modal-title" id="modal-chart">Selección de R.F.C.</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <app-help-rfc (rfc)="resultRfc($event); c('Close click');"></app-help-rfc>
  </div>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click')">
      Cerrar
    </button>
  </div>
</ng-template>


<ng-template #RFCModal let-c="close" let-d="dimiss" let-modal>
  <div class="modal-header">
    <h6 class="modal-title" id="modal-chart">R.F.C. de Empresa</h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="row d-flex justify-content-end" *ngIf="uso">
      <button class="btn btn-primary btn-xy" (click)="nuevoButtons('R')">
        <i class="fas fa-plus mr-2"></i>Nuevo
      </button>
      <button class="btn btn-success btn-xy ml-1" (click)="serviceButtons(ngFormRfc.value, 'R')"
        [disabled]="ngFormRfc.invalid || methodButtons === 'put'">
        <i class="fas fa-save mr-2"></i>Guardar
      </button>
    </div>

    <div class="divider"></div>

    <form [formGroup]="ngFormRfc">
      <div class="row">
        <div class="form-group col-sm-4 col-md-4 col-lg-3 col-xl-3">
          <label>Empresa</label>
          <input type="text" class="form-control" formControlName="Empresa" readonly>
        </div>
        <div class="form-group col-sm-6 col-md-6 col-lg-4 col-xl-4">
          <label class="col-sm-1 control-label">R.F.C.</label>
          <div class="input-group">
            <input type="text" class="form-control" formControlName="Rfc" [readonly]="methodButtons === 'put'">
            <span class="input-group-append" *ngIf="uso ">
              <button class="btn btn-info" (click)="openModal(modalRfc)" [disabled]="methodButtons === 'put'">
                <i class="fa fa-search"></i>
              </button>
            </span>
          </div>
        </div>
      </div>
    </form>
    <kendo-grid [data]="gridDataRFC" [height]="300" [selectable]="true" (selectionChange)="selectedRFC($event)">
      <div *ngIf="gridDataRFC.length !== 0">
        <kendo-grid-column field="Empresa" title="Empresa" width="120">
        </kendo-grid-column>
        <kendo-grid-column field="Rfc" title="R.F.C." width="300">
        </kendo-grid-column>
        <kendo-grid-command-column width="70" *ngIf="uso">
          <ng-template kendoGridCellTemplate let-dataItem>
            <button class="btn btn-danger" (click)="serviceButtons(dataItem, 'R', 'delete')">
              <i class="fas fa-trash-alt"></i>
            </button>
          </ng-template>
        </kendo-grid-command-column>
      </div>
      <ng-template kendoGridNoRecordsTemplate>
        {{ noRecords }}
      </ng-template>
    </kendo-grid>
  </div>
  <div class="modal-footer">
    <button class="btn btn-secondary" (click)="c('Close click')">
      Cerrar
    </button>
  </div>
</ng-template>



<ng-template #modalEmpresa let-c="close" let-d="dimiss" let-modal>
  <div class="modal-header">
    <h6 class="modal-title" id="modal-chart">
      <span *ngIf="flagNuevo">Nueva Empresa</span>
      <span *ngIf="!flagNuevo">Editar Empresa</span>
    </h6>
    <button class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="d-flex justify-content-end" *ngIf="!flagNuevo">
      <button class="btn btn-secondary px-4 ml-1" (click)="openModalTarifas(tarifasModal)">
        <i class="fas fa-funnel-dollar mr-2"></i>Tarifas
      </button>
      <button class="btn btn-secondary px-4 ml-1" (click)="openModalRFC(RFCModal)">
        <i class="fa fa-search mr-2"></i>R.F.C.
      </button>
    </div>

    <form [formGroup]="ngForm">
      <mat-horizontal-stepper linear #stepper>
        <mat-step [label]="'Datos Principales'">
          <div class="row">
            <div class="form-group col-6 col-sm-4 col-md-3 col-lg-3 col-xl-2">
              <label>Empresa</label>
              <input type="text" class="form-control" formControlName="Empresa" appFocus [readOnly]="!flagNuevo">
            </div>
            <div class="form-group col-8 col-sm-8 col-md-5 col-lg-4 col-xl-4">
              <label>Nombre</label>
              <input type="text" class="form-control" formControlName="enombre">
            </div>
            <div class="form-group col-12 col-sm-4 col-md-4 col-lg-3 col-xl-3">
              <label>Dirección</label>
              <input type="text" class="form-control" formControlName="edireccion1">
            </div>
            <div class="form-group col-12 col-sm-4 col-md-4 col-lg-3 col-xl-3">
              <label>Colonia</label>
              <input type="text" class="form-control" formControlName="edireccion2">
            </div>
            <div class="form-group col-sm-4 col-md-2 col-lg-2 col-xl-2">
              <label>Ciudad</label>
              <input type="text" class="form-control" formControlName="eciudad">
            </div>
            <div class="form-group col-sm-4 col-md-2 col-lg-2 col-xl-2">
              <label>Estado</label>
              <div class="input-group">
                <input type="text" class="form-control" formControlName="estado">
                <span class="input-group-append" *ngIf="uso">
                  <button class="btn btn-info" (click)="openModal(modalEstado)">
                    <i class="fa fa-search"></i>
                  </button>
                </span>
              </div>
            </div>
            <div class="form-group col-sm-4 col-md-2 col-lg-2 col-xl-2">
              <label>C.P.</label>
              <input type="number" class="form-control" formControlName="ecp">
            </div>
            <div class="form-group col-sm-4 col-md-2 col-lg-2 col-xl-2">
              <label>Teléfono 1</label>
              <input type="text" class="form-control" formControlName="etelefono1">
            </div>
            <div class="form-group col-sm-4 col-md-2 col-lg-2 col-xl-2">
              <label>Teléfono 2</label>
              <input type="text" class="form-control" formControlName="etelefono2">
            </div>
            <div class="form-group col-sm-4 col-md-2 col-lg-2 col-xl-2">
              <label>Fax</label>
              <input type="text" class="form-control" formControlName="efax">
            </div>
            <div class="form-group col-12 col-sm-4 col-md-4 col-lg-3 col-xl-3">
              <label>R.F.C.</label>
              <div class="input-group">
                <input type="text" class="form-control" formControlName="rfc">
                <span class="input-group-append" *ngIf="uso">
                  <button (click)="openModal(modalRfc)" class="btn btn-info" type="button">
                    <i class="fa fa-search"></i>
                  </button>
                </span>
              </div>
            </div>
            <div class="form-group col-12 col-sm-6 col-md-4 col-lg-4 col-xl-4">
              <label>Clasificación</label>
              <kendo-combobox formControlName="Clasif" [data]="dsClasif" [textField]="'adesc'" [valueField]="'Clasif'"
                [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-12 col-sm-6 col-md-4 col-lg-4 col-xl-4">
              <label>Condiciones Crédito</label>
              <kendo-combobox formControlName="etipo" [data]="dsCondCredito" [textField]="'atdesc'"
                [valueField]="'atipo'" [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-12 col-sm-6 col-md-4 col-lg-4 col-xl-4">
              <label>Tipo Registro</label>
              <kendo-combobox formControlName="treser" [data]="dsTipoHuesped" [textField]="'tdesc'"
                [valueField]="'treser'" [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-12 col-sm-6 col-md-4 col-lg-4 col-xl-4">
              <label>Segmento</label>
              <kendo-combobox formControlName="Segmento" [data]="dsSegmentos" [textField]="'sdesc'"
                [valueField]="'Segmento'" [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-12 col-sm-6 col-md-4 col-lg-4 col-xl-4">
              <label>F.P.</label>
              <kendo-combobox [data]="dsFormasPago" formControlName="efp" [textField]="'cdesc'" [valueField]="'Codigo'"
                [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-12 col-sm-6 col-md-4 col-lg-4 col-xl-4">
              <label>Origen</label>
              <kendo-combobox formControlName="Origen" [data]="dsOrigenes" [textField]="'odesc'" [valueField]="'Origen'"
                [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-12 col-sm-6 col-md-4 col-lg-4 col-xl-4">
              <label>Sucursal</label>
              <kendo-combobox formControlName="Sucursal" [data]="dsSucursales" [textField]="'cDesc'"
                [valueField]="'Sucursal'" [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-6 col-sm-6 col-md-3 col-lg-3 col-xl-2">
              <label>Cobranza</label>
              <input type="text" class="form-control" formControlName="Cobranza">
            </div>
            <div class="form-group col-6 col-sm-6 col-md-3 col-lg-2 col-xl-2">
              <label>Factura</label>
              <kendo-combobox formControlName="efact" [data]="dsFactura" [textField]="'desc'" [valueField]="'tipo'"
                [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-6 col-sm-6 col-md-3 col-lg-2 col-xl-2">
              <label class="w-100">Refacturar</label>
              <kendo-switch formControlName="erfact"></kendo-switch>
            </div>
            <div class="form-group col-6 col-sm-6 col-md-3 col-lg-2 col-xl-2">
              <label>Forma Fact.</label>
              <kendo-dropdownlist formControlName="eenv" [data]="dsFormaFactura" [textField]="'desc'"
                [valueField]="'tipo'" [valuePrimitive]="true" class="w-100">
              </kendo-dropdownlist>
            </div>
            <div class="form-group col-12 col-sm-6 col-md-4 col-lg-4 col-xl-4">
              <label>Vendedor</label>
              <kendo-combobox formControlName="Vendedor" [data]="dsVendedores" [textField]="'vnombre'"
                [valueField]="'Vendedor'" [valuePrimitive]="true" class="w-100">
              </kendo-combobox>
            </div>
            <div class="form-group col-12 col-sm-12 col-md-8 col-lg-8 col-xl-9">
              <label>Notas</label>
              <input type="text" class="form-control" formControlName="enotas">
            </div>
            <ng-container *ngIf="!flagNuevo">
              <div class="form-group col-6 col-sm-6 col-md-2 col-lg-2 col-xl-2">
                <label>Usuario</label>
                <input type="text" class="form-control" formControlName="Usuario" readonly>
              </div>
              <div class="form-group col-6 col-sm-6 col-md-2 col-lg-2 col-xl-1">
                <label class="w-100">Inactivo</label>
                <kendo-switch formControlName="Inactivo"></kendo-switch>
              </div>
            </ng-container>
          </div>
        </mat-step>
        <mat-step [label]="'Contactos'">
          <div class="row">
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <label>Contactos</label>
              <input type="text" class="form-control form-control-sm" formControlName="econtacto1">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <label>Puesto</label>
              <input type="text" class="form-control form-control-sm" formControlName="epuesto1">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <label>Emails</label>
              <input type="text" class="form-control form-control-sm" formControlName="eemail1">
            </div>
          </div>
          <div class="row">
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="econtacto2">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="epuesto2">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg- 4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="eemail2">
            </div>
          </div>
          <div class="row">
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="econtacto3">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="epuesto3">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="eemail3">
            </div>
          </div>
          <div class="row">
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="econtacto4">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="epuesto4">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="eemail4">
            </div>
          </div>
          <div class="row">
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="econtacto5">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="epuesto5">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="eemail5">
            </div>
          </div>
          <div class="row">
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="econtacto6">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="epuesto6">
            </div>
            <div class="form-group col-sm-4 col-md-4 col-lg-4 col-xl-4">
              <input type="text" class="form-control form-control-sm" formControlName="eemail6">
            </div>
          </div>
        </mat-step>
      </mat-horizontal-stepper>
    </form>
  </div>
  <div class="modal-footer">
    <button class="btn btn-success mr-1" [disabled]="ngForm.invalid" (click)="guardar(ngForm.value)" *ngIf="uso">
      <i class="fas fa-save mr-2"></i>Guardar
    </button>
    <button class="btn btn-secondary" (click)="c('Close click')">
      Cerrar
    </button>
  </div>
</ng-template>